<?php 
require_once(__DIR__ . "/lib/noKvm.php");
if( !defined("WHMCS") ) 
{
    exit( "This file cannot be accessed directly" );
}

noKvm\noKvm::loadLang();
function noKvm_MetaData()
{
    return array( "DisplayName" => "noKvm Module", "APIVersion" => "1.0", "RequiresServer" => true );
}

function noKvm_initConfigOption()
{
    if( !isset($_POST["id"]) ) 
    {
        $data = Illuminate\Database\Capsule\Manager::table("tblproducts")->where("servertype", "noKvm")->where("id", $_GET["id"])->get();
    }
    else
    {
        $data = Illuminate\Database\Capsule\Manager::table("tblproducts")->where("servertype", "noKvm")->where("id", $_POST["id"])->get();
    }

    $packageconfigoption = array(  );
    if( is_array($data) && 0 < count($data) ) 
    {
        list($packageconfigoption[1]) = explode("|", $data[0]->configoption1);
        list($packageconfigoption[2]) = explode("|", $data[0]->configoption2);
        list($packageconfigoption[3]) = explode("|", $data[0]->configoption3);
        list($packageconfigoption[4]) = explode("|", $data[0]->configoption4);
        list($packageconfigoption[5]) = explode("|", $data[0]->configoption5);
        list($packageconfigoption[6]) = explode("|", $data[0]->configoption6);
    }

    return $packageconfigoption;
}

function noKvm_ConfigOptions()
{
    try
    {
        $packageconfigoption = nokvm_initconfigoption();
        $master = Illuminate\Database\Capsule\Manager::table("tblservers")->where("type", "noKvm")->first();
        $nokvm = new noKvm\noKvm(array( "serverid" => $master->id ));
        $areas = $nokvm->apiCall("GET", "area")->result->data;
        foreach( $areas as $val ) 
        {
            $area[] = $val->id . "|" . $val->name;
        }
        $areas = implode(",", $area);
        $plans = $nokvm->apiCall("GET", "plan")->result->data;
        foreach( $plans as $val ) 
        {
            $plan[] = $val->id . "|" . $val->name;
        }
        $plans = implode(",", $plan);
        $images = $nokvm->apiCall("GET", "mirror_image")->result->data;
        foreach( $images as $val ) 
        {
            $image[] = $val->id . "|" . $val->name;
        }
        $images = implode(",", $image);
        $iprange = implode(",", range(1, 1000));
        $configarray = array( "数据中心" => array( "Type" => "dropdown", "Size" => "30", "Options" => (string) $areas, "Description" => "<style>.module-settings select { min-width: 180px;display: block;margin-bottom: 5px;}</style>所属数据中心位置" ), "主机套餐" => array( "Type" => "dropdown", "Size" => "30", "Options" => (string) $plans, "Description" => "主控设置主机套餐配置。" ), "默认镜像" => array( "Type" => "dropdown", "Size" => "30", "Options" => (string) $images, "Description" => "默认镜像，如果设置可选配置则优先可选配置。" ), "IP 数量" => array( "Type" => "dropdown", "Size" => "30", "Options" => (string) $iprange, "Description" => "默认分配公网 IP 数量" ), "CPU模式" => array( "Type" => "dropdown", "Options" => "0|显示CPU型号,1|隐藏CPU型号", "Description" => "全局变量不读取套餐" ), "可用镜像" => array( "Type" => "dropdown", "Options" => "0|Windows 可用,1|Windows 不可用", "Description" => "当前套餐是否可用 Windows 镜像" ) );
        return $configarray;
    }
    catch( Exception $e ) 
    {
        logModuleCall("Config Options", "noKvm_ConfigOptions", "", $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_CreateAccount($params)
{
    try
    {
        $nokvm = new noKvm\noKvm($params);
        $userid = $nokvm->getParam("userid");
        $serviceid = $nokvm->getParam("serviceid");
        $clientsdetails = $nokvm->getParam("clientsdetails");
        $configOptionPlan = $nokvm->getParam("configoption2");
        $configOptionIpCount = $nokvm->getParam("configoption4") + $nokvm->getCextraip();
        $customField = $nokvm->getParam("customfields");
        $newDataPassword = $nokvm->getNewDataPassword();
        $buildGroup = $nokvm->getBuildGroup();
        $buildOS = $nokvm->getBuildOS();
        $ccpu = $nokvm->getCcpu();
        $ccpumode = $nokvm->getCcpuMode();
        $cmem = $nokvm->getCmem();
        $cdisk = $nokvm->getCdisk();
        $cextraip = $nokvm->getCextraip();
        $cnspeed = $nokvm->getCnspeed();
        $snapshot = $nokvm->getSnapshot();
        $backups = $nokvm->getBackups();
        $noVps = "";
        $r = array(  );
        if( empty($customField["vserverid"]) ) 
        {
            $noVps = "success";
        }
        else
        {
            $VMid = $customField["vserverid"];
            $result = $nokvm->apiCall("GET", "virtual/" . $VMid);
            $r = $result->result;
        }

        if( $r->code == "0" ) 
        {
            return "云主机 vserverid 已存在！";
        }

        $callArray = array( "users_id" => $userid, "username" => $clientsdetails["email"], "areas_id" => $buildGroup, "core" => $ccpu, "cpu_mode" => $ccpumode, "memory" => $cmem, "data_disk_size" => $cdisk, "net_out" => $cnspeed, "net_in" => $cnspeed, "snapshoot" => $snapshot, "backups" => $backups, "templates_id" => $buildOS, "sys_pwd" => $newDataPassword, "vnc_pwd" => $nokvm->passwordGen(), "expire_time" => "2999-12-31", "ip_num" => $configOptionIpCount );
        logModuleCall("create virtual", "", $callArray, $callArray, "");
        $result = $nokvm->apiCall("POST", "virtual", $callArray);
        $r = $result->result;
        if( $r->code == "0" ) 
        {
            $nokvm->setCustomfieldsValue("vserverid", $r->data->id);
            $mainip = $r->data->ipaddress;
            $nokvm->setHostname($r->data->name);
            foreach( $r->data->public_ip as $val ) 
            {
                if( $r->data->ip_address_id == $val->id ) 
                {
                    $mainip = $val->ip;
                }

            }
            Illuminate\Database\Capsule\Manager::table("tblhosting")->where("id", $serviceid)->update(array( "dedicatedip" => $mainip ));
            $result = "success";
        }
        else
        {
            $result = $r->message;
        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("Create Virtual", "noKvm_CreateAccount", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_SuspendAccount($params)
{
    try
    {
        if( function_exists("noKvm_suspend_pre") ) 
        {
            noKvm_suspend_pre($params);
        }

        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $results = $nokvm->apiCall("GET", "virtual_pause/" . $VMid)->result;
        if( $results->code == "0" ) 
        {
            $result = "success";
        }
        else
        {
            $result = (string) $results->message;
        }

        if( $result == "success" ) 
        {
            if( function_exists("noKvm_suspend_post_success") ) 
            {
                noKvm_suspend_post_success($params);
            }

        }
        else
        {
            if( function_exists("noKvm_suspend_post_error") ) 
            {
                noKvm_suspend_post_error($params);
            }

        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("Suspend Account", "noKvm_SuspendAccount", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_UnsuspendAccount($params)
{
    try
    {
        if( function_exists("noKvm_unsuspend_pre") ) 
        {
            noKvm_unsuspend_pre($params);
        }

        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $results = $nokvm->apiCall("GET", "virtual_restore_pause/" . $VMid)->result;
        if( $results->code == "0" ) 
        {
            $result = "success";
        }
        else
        {
            $result = (string) $results->message;
        }

        if( $result == "success" ) 
        {
            if( function_exists("noKvm_unsuspend_post_success") ) 
            {
                noKvm_unsuspend_post_success($params);
            }

        }
        else
        {
            if( function_exists("noKvm_unsuspend_post_error") ) 
            {
                noKvm_unsuspend_post_error($params);
            }

        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("Unsuspend Account", "noKvm_UnsuspendAccount", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_TerminateAccount($params)
{
    try
    {
        if( function_exists("noKvm_terminate_pre") ) 
        {
            noKvm_terminate_pre($params);
        }

        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $results = $nokvm->apiCall("DELETE", "virtual/" . $VMid)->result;
        if( $results->code == "0" ) 
        {
            $nokvm->removeipTerminatedProduct();
            $nokvm->removevserveridTerminatedProduct();
            $result = "success";
        }
        else
        {
            $result = (string) $result->message;
        }

        if( $result == "success" ) 
        {
            if( function_exists("noKvm_terminate_post_success") ) 
            {
                noKvm_terminate_post_success($params);
            }

        }
        else
        {
            if( function_exists("noKvm_terminate_post_error") ) 
            {
                noKvm_terminate_post_error($params);
            }

        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("Terminate Account", "noKvm_TerminateAccount", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_ChangePackage($params)
{
    global $_LANG;
    try
    {
        if( function_exists("noKvm_changepackage_pre") ) 
        {
            $res = noKvm_changepackage_pre($params);
            if( $res["cancel_process"] === true ) 
            {
                return $_LANG["nokvm_cancel_custom_package_change_process"];
            }

        }

        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $ccpu = $nokvm->getCcpu();
        $cmem = $nokvm->getCmem();
        $cdisk = $nokvm->getCdisk();
        $cnspeed = $nokvm->getCnspeed();
        $cextraip = $nokvm->getParam("configoption4") + $nokvm->getCextraip();
        $snapshot = $nokvm->getSnapshot();
        $backups = $nokvm->getBackups();
        $callArray = array( "core" => $ccpu, "memory" => $cmem, "data_disk_size" => $cdisk, "net_out" => $cnspeed, "net_in" => $cnspeed, "ip_num" => $cextraip );
        $call = $nokvm->apiCall("PUT", "virtual/" . $VMid, $callArray)->result;
        if( $call->code == "0" ) 
        {
            $nokvm->apiCall("PUT", "snapshot/" . $VMid, array( "snapshot" => $snapshot ));
            $nokvm->apiCall("PUT", "snapshot/" . $VMid, array( "snapshot" => $snapshot ))->result;
            $nokvm->apiCall("PUT", "backups/" . $VMid, array( "backups" => $backups ));
            $nokvm->apiCall("PUT", "backups/" . $VMid, array( "backups" => $backups ))->result;
            $result = "success";
        }
        else
        {
            $result = (string) $call->message;
        }

        logModuleCall("Change Package", "noKvm_ChangePackage", $params, $result, "");
        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("Change Package", "noKvm_ChangePackage", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_Custom_ChangePassword($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $newPassword = $postParam["newpassword"];
    $callArray = array( "type" => "system", "password" => $newPassword );
    $result = $nokvm->apiCall("PUT", "virtual_reset_password/" . $VMid, $callArray);
    $r = $result->result;
    if( $r->code == "0" ) 
    {
        $message = $_LANG["nokvm_passwordUpdated"];
        $result = (object) array( "status" => "success", "message" => $r->message, "newpassword" => $newPassword );
    }
    else
    {
        $result = (object) array( "status" => "error", "message" => $r->message );
    }

    exit( json_encode($result) );
}

function noKvm_Custom_Reinstall($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $templateID = $postParam["templateID"];
    $VMid = $customField["vserverid"];
    $call = $nokvm->apiCall("GET", "virtual_reset_system/" . $VMid . "/" . $templateID);
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_Custom_actionSnapshot($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $snapshotID = $postParam["sid"];
    switch( $postParam["request"] ) 
    {
        case "Create":
            $callArray = array( "virtual" => $VMid );
            $call = $nokvm->apiCall("POST", "snapshot", $callArray);
            break;
        case "Restore":
            $call = $nokvm->apiCall("GET", "snapshot/" . $snapshotID . "/edit");
            break;
        case "Delete":
            $call = $nokvm->apiCall("DELETE", "snapshot/" . $snapshotID);
            break;
        default:
            break;
    }
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message, "data" => $call->result->data );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_Custom_actionBackups($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $snapshotID = $postParam["sid"];
    switch( $postParam["request"] ) 
    {
        case "Create":
            $callArray = array( "virtual" => $VMid );
            $call = $nokvm->apiCall("POST", "backups", $callArray);
            break;
        case "Restore":
            $call = $nokvm->apiCall("GET", "backups/" . $snapshotID . "/edit");
            break;
        case "Delete":
            $call = $nokvm->apiCall("DELETE", "backups/" . $snapshotID);
            break;
        default:
            break;
    }
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message, "data" => $call->result->data );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_Custom_actionCdRom($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $type = $postParam["type"];
    $cdromid = $postParam["cid"];
    $call = $nokvm->apiCall("GET", "virtual_cd_rom/" . $VMid . "/" . $type . "/" . $cdromid);
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_Custom_newSecurityGroup($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $userid = $nokvm->getParam("userid");
    $name = $postParam["name"];
    $desc = $postParam["desc"];
    $callArray = array( "users_id" => $userid, "name" => $name, "desc" => $desc );
    $call = $nokvm->apiCall("POST", "security_group", $callArray);
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_Custom_actionSecurity($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $SecurityID = $postParam["sid"];
    $callArray = array( "nodes" => array( $VMid ) );
    switch( $postParam["request"] ) 
    {
        case "Apply":
            $call = $nokvm->apiCall("POST", "security_group_apply/" . $SecurityID, $callArray);
            break;
        case "Delete":
            $call = $nokvm->apiCall("DELETE", "security_group/" . $SecurityID);
            break;
        default:
            break;
    }
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message );
    }
    else
    {
        $result = (object) array( "status" => "error", "message" => $call->result->message );
    }

    exit( json_encode($result) );
}

function noKvm_Custom_createSecurityAcl($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $callArray = array( "groups_id" => $postParam["groups_id"], "orientation" => $postParam["orientation"], "tactics" => $postParam["tactics"], "type" => $postParam["type"], "port_start" => $postParam["port_start"], "port_end" => $postParam["port_end"], "ip_start" => $postParam["ip_start"], "ip_end" => $postParam["ip_end"], "level" => $postParam["level"], "desc" => $postParam["desc"] );
    $call = $nokvm->apiCall("POST", "security_group_acl", $callArray);
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message, "callArray" => $callArray );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message, "callArray" => $callArray );
    exit( json_encode($result) );
}

function noKvm_Custom_viewSecurityAcl($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $sID = $postParam["sid"];
    $call = $nokvm->apiCall("GET", "security_group_acl/" . $sID);
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message, "data" => $call->result->data );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_Custom_deleteSecurityAcl($params = "")
{
    global $_LANG;
    $nokvm = new noKvm\noKvm($params);
    $customField = $nokvm->getParam("customfields");
    $postParam = $nokvm->getParam("POST");
    $VMid = $customField["vserverid"];
    $aclID = $postParam["aid"];
    $call = $nokvm->apiCall("DELETE", "security_group_acl/" . $aclID);
    if( $call->result->code == "0" ) 
    {
        $result = (object) array( "status" => "success", "message" => $call->result->message );
        exit( json_encode($result) );
    }

    $result = (object) array( "status" => "error", "message" => $call->result->message );
    exit( json_encode($result) );
}

function noKvm_AdminCustomButtonArray()
{
    global $_LANG;
    return array( $_LANG["nokvm_boot"] => "boot", $_LANG["nokvm_reboot"] => "reboot", $_LANG["nokvm_shutdown"] => "shutdown" );
}

function noKvm_ClientAreaCustomButtonArray()
{
    return array();
    //global $_LANG;
    //return array( $_LANG["nokvm_boot"] => "boot", $_LANG["nokvm_reboot"] => "reboot", $_LANG["nokvm_shutdown"] => "shutdown" );
}

function noKvm_boot($params)
{
    try
    {
        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $call = $nokvm->apiCall("GET", "virtual_power/" . $VMid . "/start");
        if( $call->result->code == "0" ) 
        {
            $result = "success";
        }
        else
        {
            $result = (string) $nokvm->result->message;
        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("boot", "noKvm_boot", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_reboot($params)
{
    try
    {
        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $call = $nokvm->apiCall("GET", "virtual_power/" . $VMid . "/restart");
        if( $call->result->code == "0" ) 
        {
            $result = "success";
        }
        else
        {
            $result = (string) $nokvm->result->message;
        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("reboot", "noKvm_reboot", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_shutdown($params)
{
    try
    {
        $nokvm = new noKvm\noKvm($params);
        $customField = $nokvm->getParam("customfields");
        $VMid = $customField["vserverid"];
        $call = $nokvm->apiCall("GET", "virtual_power/" . $VMid . "/shut");
        if( $call->result->code == "0" ) 
        {
            $result = "success";
        }
        else
        {
            $result = (string) $nokvm->result->message;
        }

        return $result;
    }
    catch( Exception $e ) 
    {
        logModuleCall("shutdown", "noKvm_shutdown", $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }
}

function noKvm_ClientArea($params)
{
    global $_LANG;
    $nokvm = new \noKvm\noKvm($params);
    $status = $nokvm->getParam('status');
    $customField = $nokvm->getParam('customfields');
    $VMid = $customField['vserverid'];
    $userid = $nokvm->getParam('userid');
    if (isset($_GET['modop']) && $_GET['modop'] == 'custom') {
        if (isset($_GET['a'])) {
            if(!in_array($_GET['a'], array( "boot", "reboot", "shutdown" ))){
                $functionName = 'noKvm_' . 'Custom_' . $_GET['a'];
            }else{
                $functionName = 'noKvm_' . $_GET['a'];
            }
            $params['POST'] = $_POST;

            if (function_exists($functionName)) {
                $functionName($params);
            }
            else {
                $result = (object) array('success' => false, 'msg' => '命令：' . $functionName . ' 不存在');
                exit(json_encode($result));
            }
        }
    }

    if (isset($_GET['getVNC'])) {
        $result = $nokvm->noVNC($VMid);
        exit(json_encode($result));
    }

    if (isset($_GET['getChart'])) {
        $monitor = $nokvm->apiCall('GET', 'virtual_monitoring/' . $VMid)->result->data;

        foreach ($monitor as $key => $value) {
            $CreatedAt = strtotime($value->CreatedAt);
            $CreatedAt = date('H:i', $CreatedAt);
            $result['time'][$key] = $CreatedAt;
            $result['cpu'][$key] = json_decode($value->Cpu)->value;
            $result['disk'][$key]->a_read = json_decode($value->Disk)->vda[0];
            $result['disk'][$key]->a_write = json_decode($value->Disk)->vda[1];
            $result['disk'][$key]->b_read = json_decode($value->Disk)->vdb[0];
            $result['disk'][$key]->b_write = json_decode($value->Disk)->vdb[1];
            $result['network'][$key]->in = json_decode($value->Network)->in;
            $result['network'][$key]->out = json_decode($value->Network)->out;
        }

        exit(json_encode($result));
    }

    try {
        if ($status != 'Active') {
            $lang = 'clientarea' . strtolower($status);
            $result = array('status' => 'error', 'message' => '您的产品状态为：' . Lang::trans($lang));
        }

        $info = $nokvm->apiCall('GET', 'virtual/' . $VMid)->result;

        if ($info->code == '1') {
            $result = array('status' => 'error', 'message' => $info->message);
        }
        else if ($info->data->status->data[0]->code == '13') {
            $result = array('status' => 'error', 'message' => '暂停服务或已到期');
        }
        else {
            $result = array('status' => 'success');
            $info = $info->data;
            $info->trafficin = $nokvm->formatSize($info->flow->data->in);
            $info->trafficout = $nokvm->formatSize($info->flow->data->out);

            if ($info->status->code == '0') {
                $info->status = $info->status->data[0]->code;

                switch ($info->status) {
                case '1':
                    $info->status = 'Running';
                    break;

                case '2':
                    $info->status = 'Poweroff';
                    break;

                case '3':
                    $info->status = 'Pending';
                    break;

                case '4':
                    $info->status = 'Poweroff';
                    break;

                case '5':
                    $info->status = 'Creating';
                    break;

                case '8':
                    $info->status = 'Reinstalling';
                    break;

                case '11':
                    $info->status = 'Migrate';
                    break;

                case '12':
                    $info->status = 'MigrateCompleted';
                    break;

                default:
                    break;
                }
            }
            else {
                $info->status = 'offline';
            }

            $info->network_out = $info->net_out * 8 / 1024;
            $info->network_in = $info->net_in * 8 / 1024;

            foreach ($info->ip_list as $key => $val) {
                if ($info->ip_address_id != $val->id) {
                    continue;
                }

                $info->public_ip = $val->ip;
            }

            $info->private_ip = $info->private_ips->ip;
            $info->secret_group = $info->bind_security_group->bind_security_group->name;
            $backups = $nokvm->apiCall('GET', 'backups/' . $VMid)->result->data;
            $mirror_image = $nokvm->apiCall('GET', 'mirror_image')->result->data;

            foreach ($mirror_image as $key => $val) {
                if ($info->templates_id != $val->id) {
                    continue;
                }

                $info->ossystem = $val->name;
            }

            foreach ($mirror_image as $key => $value) {
                $isWindows = $nokvm->getSystem();

                if ($isWindows == '1') {
                    if ($value->type == 'windows') {
                        continue;
                    }
                }

                $templates[$value->type][$key]->id = $value->id;
                $templates[$value->type][$key]->name = $value->name;
            }

            $snapshots = $nokvm->apiCall('GET', 'snapshot/' . $VMid)->result->data;
            $securitys = $nokvm->apiCall('GET', 'security_group/' . $userid)->result->data;
            $cd_rom = $nokvm->apiCall('GET', 'cd_rom')->result->data;
        }
    }
    catch (Exception $e) {
        logModuleCall('Client Area', 'noKvm_ClientArea', $params, $e->getMessage(), $e->getTraceAsString());
        return $e->getMessage();
    }

    if (isset($_GET['json'])) {
        exit(json_encode($info));
    }

    if ($result['status'] == 'success') {
        return array(
            'overrideDisplayTitle'           => $productName,
            'tabOverviewReplacementTemplate' => 'templates/clientarea.tpl',
            'vars'                           => array('status' => $status, 'info' => $info, 'cd_rom' => $cd_rom, 'backups' => $backups, 'snapshots' => $snapshots, 'securitys' => $securitys, 'templates' => $templates, 'security_group_acl' => $security_group_acl, '_LANG' => $_LANG)
        );
    }
    return array(
        'overrideDisplayTitle'           => $productName,
        'tabOverviewReplacementTemplate' => 'templates/error.tpl',
        'vars'                           => array('result' => $result, '_LANG' => $_LANG)
    );
}

function noKvm_TestConnection($params)
{
    try
    {
        $nokvm = new noKvm\noKvm($params);
        $data = $nokvm->TestConnection($params["serverip"], $params["serveraccesshash"]);
        if( $data->code == 0 ) 
        {
            $success = true;
            $errorMsg = "";
        }
        else
        {
            $success = false;
            $errorMsg = $data->message;
        }

    }
    catch( Exception $e ) 
    {
        logModuleCall("provisioningmodule", "noKvm_TestConnection", $params, $data->message, $e->getTraceAsString());
        $success = false;
        $errorMsg = $data->message;
    }
    return array( "success" => $success, "error" => $errorMsg );
}
?>