<div class="charts">
	
	<div class="charts-section">
		<h4>月流量使用率</h4>
		<div class="row">
			<div class="col-sm-4">
				<div class="disk-usage-datas">
					上行流量: <span id="trafficout">{$info->trafficout}</span>
				</div>
			</div>
			<div class="col-sm-4">
				<div class="disk-usage-datas">
					下行流量: <span id="trafficin">{$info->trafficin}</span>
				</div>
			</div>
			<div class="col-sm-4">
				<div class="disk-usage-datas">
					<div class="usage">上行带宽：<span>{$info->network_out} Mbps</span></div>
					<div class="usage">下行带宽：<span>{$info->network_in} Mbps</span></div>
				</div>
			</div>
		</div>		
	</div>
					
	<div class="charts-section">
		
		<div class="row">
			
			<div class="col-md-12">
				<div class="chart">
					<h4 class="j-title">CPU</h4>
					<div class="labels">
						<span class="line0"></span> CPU
					</div>
					<div class="svg-inner">
						{if $info->status == 'Running'}
						<div id="cpu-chart" class="chart-div">
							<div class="preloader preloader-lg"></div>
						</div>
						{else}
							<small>暂时没有任何数据</small>
						{/if}
					</div>
				</div>
			</div>
			
			<div class="col-md-12">
				<div class="chart">
					<h4 class="j-title">
						网络
						<small>单位：KB</small>
					</h4>
					<div class="labels">
						<span class="line0"></span> 上行
						<span class="line1"></span> 下行
					</div>
					<div class="svg-inner">
						{if $info->status == 'Running'}
						<div id="network-chart" class="chart-div">
							<div class="preloader preloader-lg"></div>
						</div>
						{else}
							<small>暂时没有任何数据</small>
						{/if}
					</div>
				</div>
			</div>
				
			<div class="col-md-12">
				<div class="chart">
					<h4 class="j-title">
						硬盘
						<small>单位：KB</small>
					</h4>
					<div class="labels">
						<span class="line0"></span> 系统盘 读
						<span class="line1"></span> 系统盘 写
						<span class="line2"></span> 数据盘 读
						<span class="line3"></span> 数据盘 写
					</div>
					<div class="svg-inner">
						{if $info->status == 'Running'}
						<div id="disk-chart" class="chart-div">
							<div class="preloader preloader-lg"></div>
						</div>
						{else}
							<small>暂时没有任何数据</small>
						{/if}
					</div>
				</div>
			</div>
			
		</div>
		
	</div>
	
</div>
{if $info->status == 'Running'}
<script src="{$systemurl}modules/servers/noKvm/templates/assets/js/echarts.min.js"></script>
<script type="text/javascript">
$(document).ready(function(){
    
    var cpu 	=  echarts.init(document.getElementById('cpu-chart'));
    var disk	=  echarts.init(document.getElementById('disk-chart'));
    var network =  echarts.init(document.getElementById('network-chart'));
    
    var empty 	= '<small>暂时没有任何数据</small>';
    
    var timespen = 5000;
    var data;

    //全局变量部分
    var timer = null;

	//初始化方法
	function init(){
        
		//初始化
		updateChartData();
		timer = setInterval(function () {
			updateChartData();
		}, timespen);
	}
      
    function updateChartData() {
		var href = 'clientarea.php?action=productdetails&id={$serviceid}';
        var data = null;
        
        $.ajax({
            url: href + '&getChart',
            type: 'GET',
            dataType: 'json',
            success:function(res){
                data  = res;                
		        //开始更新每个图
		        updateCPU ( data );
		        updateNetwork ( data );
		        updateDisk ( data );
		        
	            $('#trafficout').html(data.trafficout);
	            $('#trafficin').html(data.trafficin);
            }
        });

    }

    function updateCPU ( monitoring ) {
        
        $('#cpu-chart').html();
        
        var option = {
            tooltip: {
				axisPointer: {
					type: 'line',
				},
				trigger: 'axis',
				formatter: function(params) {
					var result =params[0].axisValue+' </br>';
					params.forEach(function (item) {
						result += item.marker + " " + item.seriesName + " : " + item.value +" %</br>";
					});
					return result;
				},
				padding: [5,10]
            },
			grid: {
				left: '80',
				right: '20',
				bottom: '30',
				y: 15,
				containLabel: false
			},
            toolbox: {
                show: false,
                feature: {
                    mark: {
                        show: true
                    },
                    dataView: {
                        show: true,
                        readOnly: false
                    },
                    magicType: {
                        show: true,
                        type: ['line', 'bar', 'stack', 'tiled']
                    },
                    restore: {
                        show: true
                    },
                    saveAsImage: {
                        show: true
                    }
                }
            },
            calculable: true,
            xAxis: [{
                type: 'category',
                splitLine: {
                    show: false
                },
                boundaryGap: false,
                data: monitoring.time
            }],
            color: ["#81c2ef"],
            yAxis: [{
                type: 'value',
                splitLine: {
                    show: false
                },
				axisLabel: {
					formatter: {literal}'{value} %'{/literal}
				},
                min:0,
                max:100
            }],
            series: [{
                name: '使用率',
                type: 'line',
                smooth: true,
                itemStyle: {
                    normal: {
                        areaStyle: {
                            type: 'macarons'
                        }
                    }
                },
                data: monitoring.cpu
            }]
        };
		cpu.setOption(option,true);
		cpu.resize();
		$('small.nodata').remove();
    }

    function updateNetwork ( monitoring ) {
        $('#network-chart').html();
        //处理上行  下行
        var net_in = [],net_out = [];
        $.each(monitoring.network,function (key,val) {
            net_in.push(val.in);
            net_out.push(val.out);
        });

        var option = {
            tooltip: {
				axisPointer: {
					type: 'line',
				},
				trigger: 'axis',
				formatter: function(params) {
					var result =params[0].axisValue+' </br>';
					params.forEach(function (item) {
						result += item.marker + " " + item.seriesName + " : " + item.value +"</br>";
					});
					return result;
				},
				padding: [5,10]
            },
			grid: {
				left: '80',
				right: '20',
				bottom: '30',
				y: 15,
				containLabel: false
			},
            toolbox: {
                show: false,
                feature: {
                    mark: {
                        show: true
                    },
                    dataView: {
                        show: true,
                        readOnly: false
                    },
                    magicType: {
                        show: true,
                        type: ['line', 'bar', 'stack', 'tiled']
                    },
                    restore: {
                        show: true
                    },
                    saveAsImage: {
                        show: true
                    }
                }
            },
            calculable: true,
            xAxis: [{
                type: 'category',
                splitLine: {
                    show: false
                },
                boundaryGap: false,
                data: monitoring.time
            }],
            color: [ "#81c2ef", "#89d8af" ],
            yAxis: [{
                type: 'value',
				axisLabel: {
					formatter: function ( parms ) {
						return parms;
					}
				},
                splitLine: {
                    show: false
                }
            }],
            series: [{
                name: '下行',
                type: 'line',
                smooth: true,
                itemStyle: {
                    color: '#81c2ef'
                },
                data: net_in
            }, {
                name: '上行',
                type: 'line',
                smooth: true,
                itemStyle: {
                    color: '#89d8af'
                },
                data: net_out
            }]
        };
		network.setOption(option,true);
		network.resize();
		$('small.nodata').remove();
    }

    function updateDisk ( monitoring ) {
        $('#disk-chart').html();
        //处理数据
        var a_read = [],a_write = [],b_read = [],b_write = [];
        $.each(monitoring.disk,function (key,val) {
            a_read.push(val.a_read);
            a_write.push(val.a_write);
            b_read.push(val.b_read);
            b_write.push(val.b_write);
        });
        var option = {
            tooltip: {
				axisPointer: {
					type: 'line',
				},
				trigger: 'axis',
				formatter: function(params) {
					var result =params[0].axisValue+' </br>';
					params.forEach(function (item) {
						result += item.marker + " " + item.seriesName + " : " + item.value +"</br>";
					});
					return result;
				},
				padding: [5,10]
            },
			grid: {
				left: '80',
				right: '20',
				bottom: '30',
				y: 15,
				containLabel: false
			},
            toolbox: {
                show: false,
                feature: {
                    mark: {
                        show: true
                    },
                    dataView: {
                        show: true,
                        readOnly: false
                    },
                    magicType: {
                        show: true,
                        type: ['line', 'bar', 'stack', 'tiled']
                    },
                    restore: {
                        show: true
                    },
                    saveAsImage: {
                        show: true
                    }
                }
            },
            calculable: true,
            xAxis: [{
                type: 'category',
                splitLine: {
                    show: false
                },
                boundaryGap: false,
                data: monitoring.time
            }],
            color: [ "#81c2ef", "#89d8af","#d3c7ea","#f4c53c"],
            yAxis: [{
                type: 'value',
				axisLabel: {
					formatter: function (parms) {
						return parms;
					}
				},
                splitLine: {
                    show: false
                }
            }],
            series: [{
                name: '系统盘 读',
                type: 'line',
                smooth: true,
                itemStyle: {
                    normal: {
                        areaStyle: {
                            type: 'macarons'
                        }
                    }
                },
                data: a_read
            }, {
                name: '系统盘 写',
                type: 'line',
                smooth: true,
                itemStyle: {
                    normal: {
                        areaStyle: {
                            type: 'macarons'
                        }
                    }
                },
                data: a_write
            },{
                name: '数据盘 读',
                type: 'line',
                smooth: true,
                itemStyle: {
                    normal: {
                        areaStyle: {
                            type: 'macarons'
                        }
                    }
                },
                data: b_read
            }, {
                name: '数据盘 写',
                type: 'line',
                smooth: true,
                itemStyle: {
                    normal: {
                        areaStyle: {
                            type: 'macarons'
                        }
                    }
                },
                data: b_write
            }]
        };
		disk.setOption(option,true);
		disk.resize();
		$('small.nodata').remove();
    }

    init();
});
</script>
{/if}