<div class="config-title">
	<h4>安全组：</h4>
	<a href="javascript:newSecurityGroup();" class="btn btn-default btn-xs">
		新建安全组
	</a>
</div>
<div class="alert alert-info">
	提示：新增策略/删除策略后，请点击应用按钮生效。
</div>
<table class="config-main">
	<thead>
		<tr>
			<th>名称</th>
			<th>类型</th>
			<th>描述</th>
			<th class="text-right">操作</th>
		</tr>
	</thead>
	<tbody>
		{foreach $securitys as $security}
		<tr class="security_{$security->id}">
			<td>
				{if $info->bind_security_group->virtual_security_groups_id eq $security->id}
					<label class="label label-success" style="margin-right: 5px;">当前</label>
				{/if}
				<strong>{$security->name}</strong>
			</td>
			<td>
				{if $security->erasable eq '1'}
					系统默认
				{else}
					用户自定义
				{/if}
			</td>
			<td>
				{$security->desc}
			</td>
			<td class="text-right">
					<a href="javascript:actionSecurity('Apply', '应用 <{$security->name}> ', '{$security->id}');" class="btn btn-xs btn-success" style="margin-right: 5px;">应用</a>
					<a href="javascript:viewSecurityAcl('{$security->id}');" class="btn btn-xs btn-primary" style="margin-right: 5px;">查看</a>
				{if $security->erasable ne '1'}
					
					<a href="javascript:newSecurityAcl('{$security->id}');" class="btn btn-xs btn-primary">
						新增策略
						<i class="feather icon-plus-circle"></i>
					</a>
					
					<a href="javascript:actionSecurity('Delete', '删除 <{$security->name}> ', '{$security->id}');" class="btn btn-xs btn-danger" style="margin-left: 5px;">删除</a>
				{/if}
			</td>
		</tr>
		<tr class="security_acl_{$security->id} hidden">
			<td colspan="4">
				
				<table class="config-main">
					<thead>
						<tr>
							<th>规则方向</th>
							<th>授权策略</th>
							<th>协议类型</th>
							<th>起始端口</th>
							<th>结束端口</th>
							<th>起始地址</th>
							<th>结束地址</th>
							<th>优先级</th>
							<th>备注</th>
							<th class="text-right">操作</th>
						</tr>
					</thead>
					<tbody class="security_acl_list_{$security->id}">
						<tr><td colspan="10"><span class="preloader preloader-md"></span></td></tr>
					</tbody>
				</table>
			</td>
		</tr>
		{/foreach}
	</tbody>
</table>

<script type="text/javascript">
function actionSecurity(request, title, sid = null) {
	layer.open({
		title: title + '安全组',
		content: '确定'+ title +'安全组吗？',
		closeBtn: 0,
		shade: 0.5,
		btn: ['确定', '取消'],
		yes: function(index, layero) {
			$.ajax({
	            url: 'clientarea.php?action=productdetails&id={$serviceid}&modop=custom&a=actionSecurity',
	            type: 'POST',
				data: { request: request, sid: sid },
	            dataType: 'json',
	            beforeSend:function() {
			        layer.msg('正在请求，请稍后...');
	            },
	            success:function(data) {
		            if ( data.status == 'success' ) {
			            if ( request == 'Delete') {
					    	$('.security_'+sid).remove();
			            }				    
			            layer.msg(data.message);
		            } else {
			            layer.alert(data.message);
		            }
	            },
	            error:function(data) {
		            console.log(data);
			        layer.alert(data);
	            }
			});
		}
	});
}
function viewSecurityAcl( sid ) {
	$('.security_acl_' + sid).toggleClass('hidden');
	
	updateSecurityAcl( sid );
}

function updateSecurityAcl ( sid ) {
	$.ajax({
        url: 'clientarea.php?action=productdetails&id={$serviceid}&modop=custom&a=viewSecurityAcl',
        type: 'POST',
		data: { sid: sid },
        dataType: 'json',
        success:function(data) {
            console.log(data);
            if ( data.status == 'success' ) {
	            var avl = data.data;
	            var html = '';
	            $.each(avl,function(i, n) {
		            if ( n.orientation == '1' ) {
			            orientation = '入方向';
		            } else {
			            orientation = '出方向';
		            }
		            if ( n.tactics == '1' ) {
			            tactics = '拒绝';
		            } else {
			            tactics = '允许';
		            }
		            if ( n.erasable == '1' ) {
                		html += '<tr class="acl_'+n.id+'">' + 
                				'<td>'+orientation+'</td>' +
                				'<td>'+tactics+'</td>' +
                				'<td>'+n.type.toUpperCase()+'</td>' +
                				'<td>'+n.port_start+'</td>' +
                				'<td>'+n.port_end+'</td>' +
                				'<td>'+n.ip_start+'</td>' +
                				'<td>'+n.ip_end+'</td>' +
                				'<td>'+n.level+'</td>' +
                				'<td>'+n.desc+'</td>' +
                				'<td class="text-right"><a href="javascript:;" class="btn btn-xs btn-danger disabled">删除</a></td>'
                				'</tr>';
		            } else {
                		html += '<tr class="acl_'+n.id+'">' + 
                				'<td>'+orientation+'</td>' +
                				'<td>'+tactics+'</td>' +
                				'<td>'+n.type.toUpperCase()+'</td>' +
                				'<td>'+n.port_start+'</td>' +
                				'<td>'+n.port_end+'</td>' +
                				'<td>'+n.ip_start+'</td>' +
                				'<td>'+n.ip_end+'</td>' +
                				'<td>'+n.level+'</td>' +
                				'<td>'+n.desc+'</td>' +
                				'<td class="text-right"><a href="javascript:deleteSecurityAcl(\''+n.id+'\');" class="btn btn-xs btn-danger">删除</a></td>'
                				'</tr>';
		            }
                });
                $('.security_acl_list_'+sid).html(html);
            } else {
	            layer.alert(data.message);
            }
        },
        error:function(data) {
            layer.msg(data);
        }
	});
}

function newSecurityGroup() {
	layer.open({
		title: '新建安全组',
		shade: 0.5,
		fixed: true, //不固定
		btn: ['确定', '取消'],
		content: $('.newSecurityGroup').html(),
		yes: function(index, layero) {
			var SecurityGroup 	= $(layero).find('.SecurityGroup').val();
			var SecurityGroupDesc 	= $(layero).find('.SecurityGroupDesc').val();
			
			$.ajax({
	            url: 'clientarea.php?action=productdetails&id={$serviceid}&modop=custom&a=newSecurityGroup',
	            type: 'POST',
				data: { 
					name : SecurityGroup,
					desc : SecurityGroupDesc
				},
	            dataType: 'json',
	            beforeSend:function() {
			        parent.layer.msg('正在请求，请稍后...');
	            },
	            success:function(data) {
		            console.log(data);
		            if ( data.status == 'success' ) {	    
			            layer.msg(data.message + ' 请刷新页面！');			            
		            } else {
			            layer.alert(data.message, { shade: 0.3 });
		            }
	            },
	            error:function(data) {
		            layer.alert(data.message, { shade: 0.3 });
	            }
			});
		}
	});
}

function newSecurityAcl( sid ) {
	$('#groups_id').val(sid);
	layer.open({
		title: '新增策略',
		shade: 0.5,
		area: ['700px', '500px'],
		fixed: true, //不固定
		btn: ['确定', '取消'],
		content: $('.securityACL').html(),
		yes: function(index, layero) {
			var groups_id 	= $(layero).find('.groups_id').val();
			var orientation = $(layero).find('.orientation').val();
			var tactics 	= $(layero).find('.tactics').val();
			var type 		= $(layero).find('.type').val();
			var port_start 	= $(layero).find('.port_start').val();
			var port_end 	= $(layero).find('.port_end').val();
			var ip_start 	= $(layero).find('.ip_start').val();
			var ip_end 		= $(layero).find('.ip_end').val();
			var level 		= $(layero).find('.level').val();
			var desc 		= $(layero).find('.desc').val();
			
			$.ajax({
	            url: 'clientarea.php?action=productdetails&id={$serviceid}&modop=custom&a=createSecurityAcl',
	            type: 'POST',
				data: { 
					groups_id : groups_id,
					orientation : orientation,
					tactics : tactics,
					type : type,
					port_start : port_start,
					port_end : port_end,
					ip_start : ip_start,
					ip_end : ip_end,
					level : level,
					desc : desc
				},
	            dataType: 'json',
	            beforeSend:function() {
			        parent.layer.msg('正在请求，请稍后...');
	            },
	            success:function(data) {
		            console.log(data);
		            if ( data.status == 'success' ) {	    
			            layer.msg(data.message);
			            
					    updateSecurityAcl( sid );
			            
		            } else {
			            layer.alert(data.message, { shade: 0.3 });
		            }
	            },
	            error:function(data) {
		            layer.alert(data.message, { shade: 0.3 });
	            }
			});
		}
	});
}
	
function deleteSecurityAcl( aid ) {
	layer.open({
		title: '删除安全组策略',
		content: '确定删除安全组策略吗？',
		closeBtn: 0,
		shade: 0.5,
		btn: ['确定', '取消'],
		yes: function(index, layero) {
			$.ajax({
	            url: 'clientarea.php?action=productdetails&id={$serviceid}&modop=custom&a=deleteSecurityAcl',
	            type: 'POST',
				data: { aid: aid },
	            dataType: 'json',
	            beforeSend:function() {
			        layer.msg('正在请求，请稍后...');
	            },
	            success:function(data) {
		            console.log(data);
		            if ( data.status == 'success' ) {				    
			            layer.msg(data.message);
			            $('.acl_'+aid).remove();
		            } else {
			            layer.alert(data.message);
		            }
	            },
	            error:function(data) {
			        layer.alert(data.message);
	            }
			});
		}
	});
}
</script>
<div class="securityACL" style="display: none;">
	<div class="row">
		<div class="col-sm-6">
			<div class="form-group">
				<label for="orientation">规则方向</label>
				<select class="form-control orientation" name="orientation">
                    <option value="0">出</option>
                    <option value="1">入</option>
                </select>
			</div>
		</div>
		<div class="col-sm-6">
			<div class="form-group">
				<label for="tactics">授权策略</label>
				<select class="form-control tactics" name="tactics">
                    <option value="0">允许</option>
                    <option value="1">拒绝</option>
                </select>
			</div>
		</div>
		<div class="col-sm-6">
			<div class="form-group">
				<label for="type">授权类型</label>
				<select class="form-control type" name="type">
                    <option value="tcp">TCP</option>
                    <option value="udp">UDP</option>
                    <option value="icmp">ICMP</option>
                    <option value="all">所有</option>
                </select>
			</div>
		</div>
		<div class="col-sm-6">
			<div class="form-group">
				<label for="level">优先级</label>
				<input type="text" class="form-control level" name="level" placeholder="优先级 1-1000 （值越小越优先）" />
			</div>
		</div>
		<div class="col-sm-6">
			<div class="form-group">
				<label for="port_start">端口范围 (-1 不限制)</label>
				<div class="row">
					<div class="col-sm-6">
						<input type="text" class="form-control port_start" name="port_start" placeholder="起始端口" />
					</div>
					<div class="col-sm-6">
					<input type="text" class="form-control port_end" name="port_end" placeholder="结束端口" />
					</div>
				</div>
			</div>
		</div>
		<div class="col-sm-6">
			<div class="form-group">
				<label for="ip_start">IP范围 (0.0.0.0 不限制)</label>
				<div class="row">
					<div class="col-sm-6">
						<input type="text" class="form-control ip_start" name="ip_start" placeholder="起始IP" />
					</div>
					<div class="col-sm-6">
						<input type="text" class="form-control ip_end" name="ip_end" placeholder="结束IP" />
					</div>
				</div>
			</div>
		</div>
		<div class="col-sm-12">
			<div class="form-group">
				<label for="desc">备注</label>
				<input type="hidden" class="groups_id" id="groups_id" name="groups_id" value="{$smarty.get.sid}" />
				<textarea class="form-control desc" name="desc" rows="2" placeholder="简单备注最多 20 字"></textarea>
			</div>
		</div>
	</div>
	<script type="text/javascript">
	$(function() {
	    
	    $('.type').change(function(){
		    
			var type = $(this).children('option:selected').val();
	    
			if ( type === 'icmp' ) {
				$('.port_start').addClass('disabled').attr('disabled',true).val('-1');
				$('.port_end').addClass('disabled').attr('disabled',true).val('-1');
			} else {
				$('.port_start').removeClass('disabled').attr('disabled',false).val('');
				$('.port_end').removeClass('disabled').attr('disabled',false).val('');
			}
		    
	    });
		
	});
	</script>
</div>
<div class="newSecurityGroup" style="display: none;">
	<div class="form-group">
		<input type="text" class="form-control SecurityGroup" placeholder="请输入安全组的名称">
	</div>
	<div class="form-group">
		<input type="text" class="form-control SecurityGroupDesc" placeholder="安全组备注（限制 20 字）">
	</div>
</div>