<div class="config-title">
	<h4>镜像：</h4>
</div>
<div class="alert alert-info">
	重装系统将重新格式化系统盘分区(Windows 为 C盘 Linux 为 /dev/xvda)，数据盘分区数据不受影响！
</div>
<div class="config-main">
	<form id="rebuild_form">
		<div class="row" id="templates">
			{foreach $templates as $key => $value}
			<div class="{if {$key|count} <= 3}col-sm-3{else}col-sm-4{/if}">
				<div class="template">
					<i class="os-icon os-icon-lg os-{$key} os-linux"></i>
					<strong class="systemname">{$key}</strong>
					<span class="select-name" data-select="{$_LANG.Selectsystem}">{$_LANG.Selectsystem}</span>
					<ul class="list-unstyled system">
					{foreach from=$value item=os}
						<li data-os="{$key}" data-id="{$os->id}">{$os->name}</li>
					{/foreach}
					</ul>
				</div>
			</div>
			{/foreach}
		</div>
		
	    <div class="rebuild-footer">
		    <span id="systemname">当前镜像：{$info->ossystem}</span>
		    <button type="submit" class="confirm disabled" id="confirmbtn" disabled>{$LANG.orderForm.yes}</button>
	    </div>
	</form>
</div>
<script>
$(function () {
	
    $("#templates > div").click(function () {
	    $(this).siblings().find('.system').removeClass('show');
        $(this).addClass("selected").find('input[type=radio]').attr("checked", "checked");
        $(this).siblings().removeClass("selected").find('input[type=radio]').removeAttr("checked");
        var selectname = $('.select-name').data('select');
        $(this).siblings().find('.select-name').html(selectname);
    });
    
    $('.select-name').click(function () {
	    $(this).parent().find('.system').toggleClass('show');
    });
    
    $(".system > li").click(function () {
		$(this).addClass('active');
        $(this).siblings().removeClass('active');
        
        var osname = $(this).attr('data-os');
        var osid = $(this).attr('data-id');
        var osver = $(this).text();
        
        $(this).parent().removeClass('show');
        $(this).parent().parent().find('.select-name').html(osver);
        
        $('#systemname').html('预装镜像：'+osver);
        $('#systemname').attr('data-os', osver);
        $('#systemname').attr('data-id', osid);
        
        $('#confirmbtn').removeAttr("disabled").removeClass("disabled");
	});
    
	var form = $('#rebuild_form');
	form.submit(function(e){
		e.preventDefault();
		
		var templateID = $('#systemname').attr('data-id');
		var templateName = $('#systemname').attr('data-os');
		
		RebuildVirtualServer(templateID, templateName);
	});
	
});
var completeFlag = true;
function RebuildVirtualServer( templateID, templateName ) {
	
	if(!completeFlag) {
		return;
	}
	layer.open({
		title: '重装系统',
		content: '确定将云主机系统变更为 ' + templateName + '？',
		closeBtn: 0,
		shade: 0.5,
		btn: ['确定', '取消'],
		yes: function(index, layero) {
			var osname = '';
			$.ajax({
				method: "POST",
				url: "clientarea.php?action=productdetails&id={$serviceid}&modop=custom&a=Reinstall",
				data: { templateID: templateID },
				dataType: 'json',
				cache: false,
				beforeSend:function() {
					completeFlag = false;
					layer.msg('镜像正在重装请稍后...');
		            $('#ossystem').html('<span class="preloader"></span>');
		            $('#status').html('<span class="preloader"></span>');
				},
				complete:function() {
					completeFlag = true;
				},
				success: function(value) {
					if(value.status=='success') {
												
						layer.msg(value.message);
						
						osname = templateName;
						
					} else if (value.status=='error') {
						
						layer.alert(value.message);
						
						osname = $('#ossystem').text();
						
					};
				},
				error:function() {			
					layer.alert("服务器忙，请稍后重试");
				}
			});
			
			setTimeout(function () {
				$.ajax({
		            url: 'clientarea.php?action=productdetails&id={$serviceid}&json',
		            type: 'GET',
		            dataType: 'json',
		            success:function(data) {
			            $('#ossystem').html(osname);
				        $('#status').addClass(data.status.toLowerCase()).html('<span class="icon-status icon-'+data.status.toLowerCase()+'"></span>'+ data.status);
		            }
				});
			}, '5000');
		}
	});
}
</script>